#include "spi.h"

void release_spi (void){
    TRISC = 0b00010000;
    SSPSTAT = 0b01000000;
    SSPCON1 = 0b00000010;
    SSPCON1bits.SSPEN = 1;
}

void init_spi(void){
    SSPCON1bits.SSPEN = 0;
    TRISC = 0b00010000;

    SSPSTAT = 0x00;
    SSPSTATbits.CKE = 1;
    SSPSTATbits.SMP = 0;

    SSPCON1 = 0x00;
    SSPCON1bits.CKP = 0;
    SSPCON1bits.SSPM3 = 0;
    SSPCON1bits.SSPM2 = 0;
    SSPCON1bits.SSPM1 = 1; 
    SSPCON1bits.SSPM0 = 0;
    SSPCON1bits.SSPEN = 1;
}

BYTE writeSPI( BYTE data_out ){
    BYTE tmp;

    if(PIR1bits.SSPIF) PIR1bits.SSPIF = 0;

    tmp = SSPBUF ;   
    SSPBUF = data_out;   
    if ( SSPCON1 & 0x80 ){
        SSPCON1bits.WCOL = 0;
        return ( 254 );
    }

    while(!PIR1bits.SSPIF);
    PIR1bits.SSPIF = 0;
    return SSPBUF;
}

BYTE rcv_spi(void){ 

    BYTE temp_data;

    temp_data = writeSPI(0xFF);
    return temp_data;
}